{
SExec,
Copyright  2006 Lebedev "SoLRoN" Pavel

-+-+-+-  -+-+-+-

     .
    /  
    2     
     
 GNU,  Free Software Foundation.

       ,  
  ,      
,       
       .
      
   GNU.

-+-+-+- Englihs -+-+-+-

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
}
unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, DBGrids, DB, ASGSQLite3, Menus, ComCtrls,
  ExtCtrls;

type
  TForm1 = class(TForm)
    DB1: TASQLite3DB;
    SQL1: TASQLite3Query;
    DataSource1: TDataSource;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    GroupBox4: TGroupBox;
    Memo1: TMemo;
    Button1: TButton;
    Button4: TButton;
    Button5: TButton;
    Button2: TButton;
    GroupBox5: TGroupBox;
    DBGrid1: TDBGrid;
    MainMenu1: TMainMenu;
    Database1: TMenuItem;
    Open1: TMenuItem;
    Close1: TMenuItem;
    Compact1: TMenuItem;
    Exit1: TMenuItem;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    ListBox2: TListBox;
    TabSheet2: TTabSheet;
    ListBox1: TListBox;
    N1: TMenuItem;
    Options1: TMenuItem;
    About1: TMenuItem;
    Encode1: TMenuItem;
    UTF81: TMenuItem;
    Windows1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox2Click(Sender: TObject);
    procedure ExecSQL;
    procedure Close1Click(Sender: TObject);
    procedure Compact1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure UTF81Click(Sender: TObject);
    procedure Windows1Click(Sender: TObject);
    procedure ListBox2DblClick(Sender: TObject);
    procedure ResizeGrid;
    procedure ListBox1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ResizeGrid;
var i:integer;
begin
for i:=0 to DBGrid1.Columns.Count-1 do
  DBGrid1.Columns[i].Width:=round(DBGrid1.Width/DBGrid1.Columns.Count)-6;
  DB1.GetTableNames(ListBox2.Items);
end;

procedure TForm1.ExecSQL;
begin
  SQL1.Active:=False;
  SQL1.SQL.Clear;
  SQL1.SQL:=Memo1.Lines;
  SQL1.ExecSQL;
  ResizeGrid;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ExecSQL;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
OpenDialog1.FileName:='';
OpenDialog1.Execute;
if OpenDialog1.FileName<>'' then
  Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
SaveDialog1.FileName:='';
SaveDialog1.Execute;
If SaveDialog1.FileName<>'' then
  Memo1.Lines.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=116 then ExecSQL;
end;

procedure TForm1.ListBox2Click(Sender: TObject);
begin

//MessageDlg(ListBox2.Items[ListBox2.ItemIndex],mtInformation,[mbOK],0);
DB1.GetFieldNames(ListBox2.Items[ListBox2.ItemIndex],ListBox1.Items);
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
  DB1.Close;
  Form1.Caption:='SExec';
end;

procedure TForm1.Compact1Click(Sender: TObject);
begin
  DB1.SQLite3_ExecSQL('VACUUM');
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
OpenDialog1.FileName:='';
OpenDialog1.Execute;
if FileExists(OpenDialog1.FileName) then
  begin
    DB1.Close;
    DB1.DefaultDir:=ExtractFilePath(OpenDialog1.FileName);
    DB1.Database:=ExtractFileName(OpenDialog1.FileName);
    Form1.Caption:='SExec'+OpenDialog1.FileName;
    DB1.Open;
    DB1.Connected:=True;
    DB1.GetTableNames(ListBox2.Items);
  end
else
  MessageDlg('File not found: '+OpenDialog1.FileName,mtError,[mbOK],0);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  DB1.Close;
  Close;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  MessageDlg('SExec, Copyright  2006 Lebedev "SoLRoN" Pavel'+#13+'Email: solron@mail15.com'+#13+'This program is free software. You can redistribute it and/or modify it under the terms of the GNU GPL',mtInformation,[mbOK],0);
end;

procedure TForm1.UTF81Click(Sender: TObject);
begin
  DB1.CharacterEncoding:='UTF8';
  UTF81.Checked:=true;
end;

procedure TForm1.Windows1Click(Sender: TObject);
begin
  DB1.Close;
  DB1.CharacterEncoding:='STANDARD';
  DB1.Open;
  Windows1.Checked:=true;
end;

procedure TForm1.ListBox2DblClick(Sender: TObject);
begin
  SQL1.Close;
  SQL1.SQL.Clear;
  SQL1.SQL.Add('select * from '+ListBox2.Items[ListBox2.ItemIndex]);
  SQL1.ExecSQL;
  ResizeGrid;
end;

procedure TForm1.ListBox1DblClick(Sender: TObject);
begin
  SQL1.Close;
  SQL1.SQL.Clear;
  SQL1.SQL.Add('select '+ListBox1.Items[ListBox1.ItemIndex]+' from '+ListBox2.Items[ListBox2.ItemIndex]);
  SQL1.ExecSQL;
  ResizeGrid;
end;

end.
